//==========================================================================;
//
//  THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY
//  KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
//  IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A PARTICULAR
//  PURPOSE.
//
//  Copyright (c) 2009 Interlink Electronics, Inc.
//--------------------------------------------------------------------------;
//
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Diagnostics;
using System.Threading;


namespace ePad_VisionDemo
{
    public partial class Form1 : Form
    {
        private string agreetext = null;
        private string complitext = null;
        private string affirmtext = null;
        ePad_VisionDemo.ePadVisDemo dc = null;
        Thread dcthread, waitThread;

        public string Agreetext
        {
            get
            {
                return agreetext;
            }
        }
        public string Complitext
        {
            get
            {
                return complitext;
            }
        }
        public string Affirmtext
        {
            get
            {
                return affirmtext;
            }
        }
        public Form1()
        {
            InitializeComponent();
            if ( agreetext == null )
                agreetext = this.textBox1.Text;
            if ( complitext == null )
                complitext = this.textBox2.Text;
            if ( affirmtext == null )
                affirmtext = this.textBox3.Text;
            button4.Select();
            waitThread = null;
            dcthread = null;
        }
        private void waitForDC()
        {
waitagain:
            uint ret = Win32.WaitForSingleObject(dc.m_DoneEvent, 0xFFFFFFFF);
            Trace.WriteLine("waitForDC wakeup " + ret);
            if (dc.Status == false)
            {
                //MessageBox.Show("Please insert an ePad-vision Device and repress the button.");
                return;
            }
            else
            {
                DialogResult dr = MessageBox.Show("The Demo process is complete, Run again?", "ePad-vision Widget Demo", MessageBoxButtons.YesNo);
                if (dr.Equals(DialogResult.Yes))
                {
                    Win32.ResetEvent(dc.m_DoneEvent);
                    if (dcthread.IsAlive)
                    {
                        Trace.WriteLine("dcthread start again...");
                        dcthread.Start();
                    }
                    else
                    {
                        Trace.WriteLine("dcthread done, needs to restart...");
                        dcthread = null;
                        GC.Collect();
                        dcthread = new Thread(new ThreadStart(dc.Start));
                        dcthread.Start();
                    }
                    goto waitagain;
                }
                else
                {
                    dc.Status = false;
                    Application.Exit();
                }
            }            
        }
        private void button4_Click(object sender, EventArgs e)
        {
            try
            {
                if (dc == null)
                {
                    dc = new ePadVisDemo();
                    dc.AgreeText = this.Agreetext;
                    dc.CompliText = this.Complitext;
                    dc.AffirmText = this.Affirmtext;
                }
                if (dcthread == null || dcthread.IsAlive != true)
                {
                    dcthread = new Thread(new ThreadStart(dc.Start));
                    dcthread.Start();
                    Trace.WriteLine("dcthread id = " + dcthread.ManagedThreadId);
                }

                if (waitThread == null)
                {
                    waitThread = new Thread(new ThreadStart(waitForDC));
                    waitThread.Start();
                    Trace.WriteLine("waitThread id = " + waitThread.ManagedThreadId);
                }
            }
            catch
            {
                MessageBox.Show("Can not find the ePad service component, please re-run the Universal Installer.", "ePad-vision Demo Test", MessageBoxButtons.OK, MessageBoxIcon.Stop);
            }
        }

        private void button1_Click(object sender, EventArgs e)
        {
            if (textBox1.Text.Length <= 0)
            {
                textBox1.Text = agreetext;
            } 
            else
                agreetext = textBox1.Text;

        }

        private void button2_Click(object sender, EventArgs e)
        {
            if (textBox2.Text.Length <= 0)
            {
                textBox2.Text = complitext;
            }
            else
                complitext = textBox2.Text;
        }

        private void button3_Click(object sender, EventArgs e)
        {
            if (textBox3.Text.Length <= 0)
            {
                textBox3.Text = affirmtext;
            }
            else
                affirmtext = textBox3.Text;
        }

        private void agree_changed(object sender, EventArgs e)
        {
            button1.Enabled = true;
            if (textBox1.Text.Length > 90)
            {
                textBox1.ScrollBars = ScrollBars.Vertical;
            }
            else
            {
                textBox1.ScrollBars = ScrollBars.None;
            }
        }

        private void compil_changed(object sender, EventArgs e)
        {
            button2.Enabled = true;
            if (textBox2.Text.Length > 90)
            {
                textBox2.ScrollBars = ScrollBars.Vertical;
            }
            else
            {
                textBox2.ScrollBars = ScrollBars.None;
            }
        }

        private void affirm_changed(object sender, EventArgs e)
        {
            button3.Enabled = true;
            if ( textBox3.Text.Length > 90) {
                textBox3.ScrollBars = ScrollBars.Vertical;
            } else {
                textBox3.ScrollBars = ScrollBars.None;
            }
        }

        private void On_Closing(object sender, FormClosingEventArgs e)
        {
            if (null != dc)
            {
                dc.Status = false;
                Win32.SetEvent(dc.m_hCloseFormEvent);
                Trace.WriteLine("on closing set event, status = " + dc.Status);

                Win32.SetEvent(dc.m_DoneEvent);
                Application.Exit();
            }
        }
    }
}